#ifndef __ALLFUNCTIONS__H__
#define __ALLFUNCTIONS__H__

#include "Arduino.h"


// //Forward declarations to make PlatformIO happy
void setupAP(void);
void setupMQTT(void);
void StatusToDisplay(int item);
void handleRootAP();
void handleRootMQTT();
void handleNotFoundAP();
void handleSubmit();
void connect();
void readConfig (void);
void callback(char* topic, byte* payload, unsigned int length);
void handleRFID(void);
void write_to_Memory(String s,String p,String i, String g, byte w, byte r, byte f);
void write_EEPROM(String x,int pos);
void MessageToDisplay(int ID, String clearText, String addnText);
boolean APDUtrancieve(String in);
boolean setAuthKey(String Sdata);
void LastMessageDisplay(void);
void popRFIDerror(void);
boolean RequestMifare(void);
boolean RequestAuthUltralightC(void);
void byte2charArray(byte *in, char *out, int len_in);
boolean HandleDESFire(void);
void sendUID(char *UID, char *KeyOld, char *KeyNew);
void char2byteArray(String in, byte *out, int len_in);
void dump_byte_array(byte *buffer, byte bufferSize);
String printHex(byte *buffer, byte bufferSize);
void rol(byte *data, int len);
byte char2byte(char *s);
void display2lines(String str1, String str2);
void display2linesRAW(String str1, String str2);

#endif